import React from 'react';
import PropTypes from 'prop-types';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var Button = function (_React$Component) {
  inherits(Button, _React$Component);

  function Button(props) {
    classCallCheck(this, Button);

    var _this = possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.onClick = function (e) {
      e.preventDefault();

      if (_this.props.onClick) {
        _this.props.onClick(_this.props.data);
      }
    };

    return _this;
  }

  createClass(Button, [{
    key: "render",
    value: function render() {
      // text between opening and closing tag takes precedence
      var text = typeof this.props.children === "string" ? this.props.children : this.props.label;

      // disabled overrides mode
      var mode = this.props.disabled ? 'disabled' : this.props.mode;

      // disabled mode triggers disabled flag
      var disabled = this.props.disabled || this.props.mode === 'disabled';

      // loader (if busy
      var loader = null;
      if (this.props.mode === 'busy') {
        disabled = true;
        loader = React.createElement(
          "div",
          { className: "etui-loader-container" },
          React.createElement(
            "div",
            { className: "etui-loader" },
            React.createElement("div", { className: "etui-loader-bar" }),
            React.createElement("div", { className: "etui-loader-bar" }),
            React.createElement("div", { className: "etui-loader-bar" })
          )
        );
      }

      return React.createElement(
        "button",
        { className: "etui-button size-" + this.props.size + " mode-" + mode,
          onClick: this.onClick,
          disabled: disabled },
        React.createElement(
          "span",
          null,
          text
        ),
        loader
      );
    }
  }]);
  return Button;
}(React.Component);

// Properties


Button.propTypes = {
  onClick: PropTypes.func,
  disabled: PropTypes.bool,
  data: PropTypes.any,
  label: PropTypes.string,
  size: PropTypes.oneOf(["small", "medium", "large"]),
  mode: PropTypes.oneOf(["regular", "disabled", "cancel", "busy"])
};

Button.defaultProps = {
  disabled: false,
  label: "ok",
  size: "medium",
  mode: "regular"

  // and export
};

var Checkbox = function (_React$Component) {
  inherits(Checkbox, _React$Component);

  function Checkbox(props) {
    classCallCheck(this, Checkbox);

    var _this = possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.init(props);

    return _this;
  }

  createClass(Checkbox, [{
    key: "render",
    value: function render() {
      var labelStyle = {};
      if (this.props.colorLabel) {
        labelStyle["color"] = this.props.colorLabel;
      }
      var label = this.props.label ? React.createElement(
        "div",
        { className: "label", onClick: this.onClick, style: labelStyle },
        this.props.label
      ) : null;
      return React.createElement(
        "div",
        { className: "etui-checkbox label-position-" + this.props.labelPosition },
        this.props.labelPosition === "top" || this.props.labelPosition === "left" ? label : null,
        React.createElement(
          "div",
          { className: "checkbox " + (this.state.checked ? 'checked' : '') },
          React.createElement("div", { className: "box", onClick: this.onClick, id: this.props.id }),
          this.state.checked ? React.createElement("div", { className: "mark", onClick: this.onClick }) : null
        ),
        this.props.labelPosition === "bottom" || this.props.labelPosition === "right" ? label : null
      );
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.entity !== this.props.entity) {
        this.setState(this.init(nextProps));
      }
    }
  }]);
  return Checkbox;
}(React.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.init = function (props) {
    _this2._initialValue = Boolean(props.entity[props.property]);
    return {
      checked: Boolean(props.entity[props.property])
    };
  };

  this.onClick = function () {
    var checked = !_this2.state.checked;
    var isDirty = checked !== _this2._initialValue;

    // fire event handler
    if (_this2.props.onChange) {
      _this2.props.onChange({
        data: _this2.props.data,
        entity: _this2.props.entity,
        property: _this2.props.property,
        value: checked,
        isDirty: isDirty
      });
    }

    // inform watcher
    if (_this2.props.watcher) {
      if (_this2.props.watcher.change) {
        _this2.props.watcher.change(_this2.props.property, checked, isDirty);
      }
    }

    // update state
    _this2.setState(_extends({}, _this2.state, { checked: checked }));
  };
};

Checkbox.propTypes = {
  entity: PropTypes.object,
  property: PropTypes.string,
  watcher: PropTypes.object,
  onChange: PropTypes.func,
  data: PropTypes.any,
  id: PropTypes.string,
  label: PropTypes.string,
  labelPosition: PropTypes.oneOf(["top", "right", "bottom", "left"]),
  colorLabel: PropTypes.string
};

Checkbox.defaultProps = {
  entity: { "checked": true },
  property: "checked",
  labelPosition: "right"

};

var ConfirmButton = function (_React$Component) {
  inherits(ConfirmButton, _React$Component);

  function ConfirmButton(props) {
    classCallCheck(this, ConfirmButton);

    var _this = possibleConstructorReturn(this, (ConfirmButton.__proto__ || Object.getPrototypeOf(ConfirmButton)).call(this, props));

    _this.onClick = function (e) {
      if (!_this.props.disabled) {
        _this.setState(_extends({}, _this.state, { isAsking: true }));
      }
    };

    _this.onYes = function (e) {
      if (_this.props.onConfirm) {
        _this.props.onConfirm(_this.props.data);
      }
      _this.setState(_extends({}, _this.state, { isAsking: false }));
    };

    _this.onNo = function (e) {
      if (_this.props.onCancel) {
        _this.props.onCancel(_this.props.data);
      }
      _this.setState(_extends({}, _this.state, { isAsking: false }));
    };

    _this.state = {
      isAsking: false
    };
    return _this;
  }

  createClass(ConfirmButton, [{
    key: "render",
    value: function render() {
      // text between opening and closing tag takes precedence
      var label = typeof this.props.children === "string" ? this.props.children : this.props.label;
      var content = null;
      if (!this.state.isAsking) {
        content = React.createElement(
          "span",
          { className: "main " + (this.props.disabled ? 'disabled' : ''), onClick: this.onClick },
          label
        );
      } else {
        content = [React.createElement(
          "span",
          { key: "yes", className: "yes", onClick: this.onYes },
          this.props.labelYes
        ), React.createElement(
          "span",
          { key: "confirm", className: "confirm" },
          this.props.labelConfirm
        ), React.createElement(
          "span",
          { key: "no", className: "no", onClick: this.onNo },
          this.props.labelNo
        )];
      }

      return React.createElement(
        "div",
        { className: "etui-confirmbutton size-" + this.props.size },
        content
      );
    }
  }]);
  return ConfirmButton;
}(React.Component);

// Properties


ConfirmButton.propTypes = {
  onConfirm: PropTypes.func,
  onCancel: PropTypes.func,
  disabled: PropTypes.bool,
  data: PropTypes.any,
  label: PropTypes.string.isRequired,
  labelConfirm: PropTypes.string.isRequired,
  labelYes: PropTypes.string.isRequired,
  labelNo: PropTypes.string.isRequired,
  size: PropTypes.oneOf(["small", "medium", "large"])
};

ConfirmButton.defaultProps = {
  disabled: false,
  label: "delete",
  labelConfirm: 'sure?',
  labelYes: 'yes',
  labelNo: 'no',
  size: "small"

  // and export
};

var Label = function (_React$Component) {
  inherits(Label, _React$Component);

  function Label() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, Label);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = Label.__proto__ || Object.getPrototypeOf(Label)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
      console.log('clickety the labely');
      if (_this.props.for) {
        window.document.getElementById(_this.props.for).click();
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(Label, [{
    key: "render",
    value: function render() {
      /*
      let children = React.Children.map(this.props.children, child => {
        return React.cloneElement(child, {label:this.props.label})
      })
       return children
      */
      React.Children.forEach(this.props.children, function (child) {
        console.log(child);
        //return React.cloneElement(child, {label:this.props.label})
      });
      return React.createElement(
        "div",
        { className: "etui-label", onClick: this.onClick },
        this.props.children
      );
    }
  }]);
  return Label;
}(React.Component);

Label.propTypes = {
  for: PropTypes.string,
  //children:PropTypes.element.isRequired,s
  position: PropTypes.oneOf(["top", "right", "bottom", "left"])
};

Label.defaultProps = {
  position: "top"
};

var Positions = {
  top: "top",
  bottom: "bottom",
  left: "left",
  right: "right"
};

var pink = "#fa569f";

var colors = {
  primary_background: pink,
  primary_text: "white",
  primary_background_disabled: "silver",
  primary_text_disabled: "white",
  error: "red",
  white: "white"
};

var button = {
  backgroundColor: "primary_background",
  color: "primary_text",

  backgroundColor_disabled: "primary_background_disabled",
  color_disabled: "primary_text_disabled",

  backgroundColor_busy: "primary_background_disabled",
  color_busy: "primary_text_disabled",

  backgroundColor_cancel: "error",
  color_cancel: "white",

  font_size_small: "12px",
  font_size_medium: "14px",
  font_size_large: "18px",

  border_radius_small: "8px",
  border_radius_medium: "4px",
  border_radius_large: "2px"
};

var confirmButton = {
  backgroundColor: "primary_background",
  color: "primary_text",

  backgroundColor_disabled: "primary_background_disabled",
  color_disabled: "primary_text_disabled",

  backgroundColor_yes: "primary_background",
  color_yes: "primary_text",

  backgroundColor_no: "error",
  color_no: "white",

  backgroundColor_confirm: "#555555",
  color_confirm: "white",

  font_size_small: "12px",
  font_size_medium: "14px",
  font_size_large: "18px",

  border_radius_small: "8px",
  border_radius_medium: "4px",
  border_radius_large: "2px"
};

var checkbox = {
  color_box: pink,
  color_checkmark: "#ffffff",
  color_label: pink
};

var defaultTheme = {
  colors: colors,
  Button: button,
  ConfirmButton: confirmButton,
  Checkbox: checkbox
};

function make() {
  var theme = Theme.theme();

  return "\n  button.etui-button {\n    box-sizing:border-box;\n    border:none;\n    padding:1px;\n    outline:none;\n    cursor:pointer;\n    position:relative;\n  }\n  \n  button.etui-button:focus {\n    outline:none;\n  }\n  \n  button.etui-button span {\n    display:inline-block;\n    color:" + (theme.colors[theme.Button.color] || theme.Button.color) + ";\n    background-color:" + (theme.colors[theme.Button.backgroundColor] || theme.Button.backgroundColor) + ";\n  }\n  \n  button.etui-button:disabled span {\n    color:" + (theme.colors[theme.Button.color_disabled] || theme.Button.color_disabled) + ";\n    background-color:" + (theme.colors[theme.Button.backgroundColor_disabled] || theme.Button.backgroundColor_disabled) + ";\n    cursor:not-allowed;\n  }\n  \n  button.etui-button.size-small span {\n    border-radius:" + theme.Button.border_radius_small + ";\n    padding:4px 8px 4px 8px;\n    font-size:" + theme.Button.font_size_small + ";\n  }\n  \n  button.etui-button.size-medium span {\n    border-radius:" + theme.Button.border_radius_medium + ";\n    padding:8px 16px 8px 16px;\n    font-size:" + theme.Button.font_size_medium + ";\n  }\n  \n  button.etui-button.size-large span {\n    border-radius:" + theme.Button.border_radius_large + ";\n    padding:16px 32px 16px 32px;\n    font-size:" + theme.Button.font_size_large + ";\n  }\n  \n  button.etui-button.mode-cancel span {\n    color:" + (theme.colors[theme.Button.color_cancel] || theme.Button.color_cancel) + ";\n    background-color:" + (theme.colors[theme.Button.backgroundColor_cancel] || theme.Button.backgroundColor_cancel) + ";\n  }\n  \n  button.etui-button .etui-loader-container {\n    position:absolute;\n    top:0;\n    width:100%;\n    height:100%;\n    padding:1px;\n  }\n  \n  button.etui-button .etui-loader {\n    background-color:" + (theme.colors[theme.Button.backgroundColor_disabled] || theme.Button.backgroundColor_disabled) + ";\n    padding:10px 0 10px 0;\n    width:100%;\n    height:100%;\n  }\n  \n  button.etui-button .etui-loader-bar {\n    display: inline-block;\n    margin:0px 2px 0px 2px;\n    width: 4px;\n    height: 100%;\n    border-radius: 4px;\n    animation: etui-button-loader-animation 1s ease-in-out infinite;\n    background-color:" + (theme.colors[theme.Button.color_disabled] || theme.Button.color_disabled) + ";\n  }\n  \n  button.etui-button .etui-loader-bar:nth-child(1) {\n    animation-delay:0;\n  }\n  button.etui-button .etui-loader-bar:nth-child(2) {\n    animation-delay:0.10s;\n  }\n  button.etui-button .etui-loader-bar:nth-child(3) {\n    animation-delay:0.20s;\n  }\n  \n  @keyframes etui-button-loader-animation {\n    0% {\n      transform: scale(1);\n    }\n    20% {\n      transform: scale(1, 2.2);\n    }\n    40% {\n      transform: scale(1);\n    }\n  }\n  \n  ";
}

var ButtonCss = { make: make };

function make$1() {
  var theme = Theme.theme();

  return "\n  div.etui-checkbox {\n    box-sizing:border-box;\n    display:inline-flex;\n    position:relative;\n    cursor:pointer;\n  }\n  \n  div.etui-checkbox .label {\n    font-size:14px;\n    user-select:none;\n    color:" + (theme.colors[theme.Checkbox.color_label] || theme.Checkbox.color_label) + ";\n  }\n  \n  div.etui-checkbox.label-position-top,\n  div.etui-checkbox.label-position-bottom {\n    flex-direction:column;\n    align-items:center;\n  }\n  \n  div.etui-checkbox.label-position-right,\n  div.etui-checkbox.label-position-left {\n    flex-direction:row;\n  }\n  \n  div.etui-checkbox.label-position-right .label {\n    padding-left:2px;\n  }\n  \n  div.etui-checkbox.label-position-left .label {\n    padding-right:2px;\n  }\n  \n  \n  div.etui-checkbox .checkbox {\n    display:inline-block;\n    position:relative;\n    \n    width:16px;\n    height:16px;\n  }\n  \n  div.etui-checkbox .checkbox .box {\n    position:absolute;\n    top:0; left:0;\n    width:16px;\n    height:16px;\n    background-color: " + (theme.colors[theme.Checkbox.color_checkmark] || theme.Checkbox.color_checkmark) + ";\n    border:1px solid " + (theme.colors[theme.Checkbox.color_box] || theme.Checkbox.color_box) + ";\n    border-radius:2px;\n  }\n  \n  div.etui-checkbox .checkbox.checked .box {\n    background-color: " + (theme.colors[theme.Checkbox.color_box] || theme.Checkbox.color_box) + ";\n  }\n  \n  div.etui-checkbox .checkbox .mark {\n    display:inline-block;\n    position:absolute;\n    top:2px;left:5px;\n  }\n  \n  div.etui-checkbox .checkbox .mark:after {\n    /*Add another block-level blank space*/\n    content: '';\n    display: block;\n \n    /*Make it a small rectangle so the border will create an L-shape*/\n    width: 4px;\n    height: 8px;\n \n    /*Add a white border on the bottom and left, creating that 'L' */\n    border: solid " + (theme.colors[theme.Checkbox.color_checkmark] || theme.Checkbox.color_checkmark) + ";\n    border-width: 0 2px 2px 0;\n \n    /*Rotate the L 45 degrees to turn it into a checkmark*/\n    transform: rotate(45deg);\n  }\n  ";
}

var CheckboxCss = { make: make$1 };

function make$2() {
  var theme = Theme.theme();

  return "\n  div.etui-confirmbutton {\n    display:inline-block;\n    padding:1px;\n    box-sizing:border-box;\n  }\n  \n  div.etui-confirmbutton span {\n    box-sizing:border-box;\n    display:inline-block;\n    cursor:pointer;\n  }\n  \n  div.etui-confirmbutton span.main {\n    color:" + (theme.colors[theme.ConfirmButton.color] || theme.ConfirmButton.color) + ";\n    background-color:" + (theme.colors[theme.ConfirmButton.backgroundColor] || theme.ConfirmButton.backgroundColor) + "; \n  }\n  div.etui-confirmbutton span.main.disabled {\n    color:" + (theme.colors[theme.ConfirmButton.color_disabled] || theme.ConfirmButton.color_disabled) + ";\n    background-color:" + (theme.colors[theme.ConfirmButton.backgroundColor_disabled] || theme.ConfirmButton.backgroundColor_disabled) + ";\n    cursor:not-allowed;\n  }\n  \n  div.etui-confirmbutton span.yes {\n    color:" + (theme.colors[theme.ConfirmButton.color_yes] || theme.ConfirmButton.color_yes) + ";\n    background-color:" + (theme.colors[theme.ConfirmButton.backgroundColor_yes] || theme.ConfirmButton.backgroundColor_yes) + "; \n  }\n \n  div.etui-confirmbutton span.no {\n    color:" + (theme.colors[theme.ConfirmButton.color_no] || theme.ConfirmButton.color_no) + ";\n    background-color:" + (theme.colors[theme.ConfirmButton.backgroundColor_no] || theme.ConfirmButton.backgroundColor_no) + "; \n  }\n  div.etui-confirmbutton span.confirm {\n    color:" + (theme.colors[theme.ConfirmButton.color_confirm] || theme.ConfirmButton.color_confirm) + ";\n    background-color:" + (theme.colors[theme.ConfirmButton.backgroundColor_confirm] || theme.ConfirmButton.backgroundColor_confirm) + ";\n  }\n  \n  \n  div.etui-confirmbutton.size-small span {\n    padding:4px 8px 4px 8px;\n    font-size:" + theme.ConfirmButton.font_size_small + ";\n  } \n  div.etui-confirmbutton.size-small span.main {\n    border-radius:" + theme.ConfirmButton.border_radius_small + ";\n  }\n  div.etui-confirmbutton.size-small span.yes {\n    border-radius:" + theme.ConfirmButton.border_radius_small + " 0 0 " + theme.ConfirmButton.border_radius_small + ";\n  }\n  div.etui-confirmbutton.size-small span.no {\n    border-radius:0 " + theme.ConfirmButton.border_radius_small + " " + theme.ConfirmButton.border_radius_small + " 0;\n  }\n  \n  div.etui-confirmbutton.size-medium span {\n    padding:8px 16px 8px 16px;\n    font-size:" + theme.ConfirmButton.font_size_medium + ";\n  }\n  div.etui-confirmbutton.size-medium span.main {\n    border-radius:" + theme.ConfirmButton.border_radius_medium + ";\n  }\n  div.etui-confirmbutton.size-medium span.yes {\n    border-radius:" + theme.ConfirmButton.border_radius_medium + " 0 0 " + theme.ConfirmButton.border_radius_medium + ";\n  }\n  div.etui-confirmbutton.size-medium span.no {\n    border-radius:0 " + theme.ConfirmButton.border_radius_medium + " " + theme.ConfirmButton.border_radius_medium + " 0;\n  }\n  \n  div.etui-confirmbutton.size-large span {\n    padding:16px 32px 16px 32px;\n    font-size:" + theme.ConfirmButton.font_size_large + ";\n  }\n  div.etui-confirmbutton.size-large span.main {\n    border-radius:" + theme.ConfirmButton.border_radius_large + ";\n  }\n  div.etui-confirmbutton.size-large span.yes {\n    border-radius:" + theme.ConfirmButton.border_radius_large + " 0 0 " + theme.ConfirmButton.border_radius_large + ";\n  }\n  div.etui-confirmbutton.size-large span.no {\n    border-radius:0 " + theme.ConfirmButton.border_radius_large + " " + theme.ConfirmButton.border_radius_large + " 0;\n  }\n  \n  \n  ";
}

var ConfirmButtonCss = { make: make$2 };

function make$3() {
  var theme = Theme.theme();

  return "\n  div.etui-label {\n    font-size:14px;\n    user-select:none;\n    color:" + (theme.colors[theme.Checkbox.color] || theme.Checkbox.color) + ";\n  }\n  ";
}

var LabelCss = { make: make$3 };

function make$4() {
  var theme = Theme.theme();

  return "\n  div.etui-notification {\n    width:100%;\n    max-width:100%;\n    z-index:9999999;\n    text-align:right;\n    position:fixed;\n    bottom:0; right:0;\n    padding:8px;\n    overflow:hidden;\n    opacity:1;\n  }\n  \n  div.etui-notification-message {\n    display:inline-block;\n    max-width:100%;\n    padding:10px 20px 10px 20px;\n    white-space:nowrap;\n    textAlign:left;\n    overflow:hidden;\n    box-shadow:0px 2px 2px 0px silver;\n    background-color:#333333;\n    color:white;\n  }\n  \n  ";
}

var NotificationCss = { make: make$4 };

var __theme = __deepClone(defaultTheme);
var __timestamp = new Date().getTime();

function __merge(base, override) {
  for (var propName in override) {
    if (_typeof(base[propName]) !== 'object') {
      base[propName] = override[propName];
    } else {
      base[propName] = __merge(base[propName], override[propName]);
    }
  }
  return base;
}

function __deepClone(obj) {
  return JSON.parse(JSON.stringify(obj));
}

function __mountCss() {
  var cssButton = ButtonCss.make();
  var cssCheckbox = CheckboxCss.make();
  var cssConfirmButton = ConfirmButtonCss.make();
  var cssLabel = LabelCss.make();
  var cssNotification = NotificationCss.make();
  var css = [cssButton, cssCheckbox, cssConfirmButton, cssLabel, cssNotification].join('');

  var head = document.getElementsByTagName("head")[0];

  // unmount
  var mounted = document.querySelectorAll("[data-etui='default']");
  if (mounted) {
    mounted.forEach(function (m) {
      return head.removeChild(m);
    });
  }

  // via style
  var style = document.createElement('style');
  style.setAttribute('type', 'text/css');
  style.setAttribute('data-etui', 'default');
  if (style.styleSheet) {
    // IE
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
  head.appendChild(style);
}

function apply(theme) {
  if (theme) {
    // merge the them with the default theme
    __theme = __merge(__deepClone(defaultTheme), theme);
  } else {
    // apply the default theme
    __theme = __deepClone(defaultTheme);
  }

  __mountCss();
  __timestamp = new Date().getTime();
}

function theme() {
  return __theme;
}

function timestamp() {
  return __timestamp;
}

var Theme = { apply: apply, theme: theme, timestamp: timestamp };

var Watcher = function () {
  function Watcher() {
    classCallCheck(this, Watcher);

    //this._entity = entity
    this._dirties = {}; // one property for each dirty property ... the value is the new value
    this._eventListeners = {}; // one property for each event ... the value for each is a Set with event handler functions
  }

  /*
  get entity() {
    return this._entity
  }
   set entity(value) {
    this._entity = value
  }
   */

  createClass(Watcher, [{
    key: "getChangeset",
    value: function getChangeset() {
      var changeset = {};
      for (var key in this._dirties) {
        changeset[key] = this._dirties[key];
      }
      return changeset;
    }
  }, {
    key: "getUpdatedEntity",
    value: function getUpdatedEntity(entity) {
      var updatedEntity = JSON.parse(JSON.stringify(entity));
      var changeset = this.getChangeset();
      for (var key in changeset) {
        updatedEntity[key] = changeset[key];
      }
      return updatedEntity;
    }
  }, {
    key: "addEventListener",
    value: function addEventListener(eventName, func) {
      if (!this._eventListeners[eventName]) {
        this._eventListeners[eventName] = new Set();
      }
      this._eventListeners[eventName].add(func);
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(eventName, func) {
      if (this._eventListeners[eventName]) {
        this._eventListeners.delete(func);
      }
    }
  }, {
    key: "change",
    value: function change(property, value, isDirty) {
      if (!isDirty) {
        delete this._dirties[property];
      } else {
        this._dirties[property] = value;
      }

      // inform listeners
      if (this._eventListeners["change"]) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = this._eventListeners["change"][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var listener = _step.value;

            listener(this);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    }
  }, {
    key: "clear",
    value: function clear() {
      this._dirties = {};
    }
  }, {
    key: "isDirty",
    get: function get$$1() {
      return Object.keys(this._dirties).length > 0;
    }
  }]);
  return Watcher;
}();

/**
 * https://github.com/gre/bezier-easing
 * BezierEasing - use bezier curve for transition easing function
 * by Gaëtan Renaudeau 2014 - 2015 – MIT License
 */

// These values are established by empiricism with tests (tradeoff: performance VS precision)
var NEWTON_ITERATIONS = 4;
var NEWTON_MIN_SLOPE = 0.001;
var SUBDIVISION_PRECISION = 0.0000001;
var SUBDIVISION_MAX_ITERATIONS = 10;

var kSplineTableSize = 11;
var kSampleStepSize = 1.0 / (kSplineTableSize - 1.0);

var float32ArraySupported = typeof Float32Array === 'function';

function A (aA1, aA2) { return 1.0 - 3.0 * aA2 + 3.0 * aA1; }
function B (aA1, aA2) { return 3.0 * aA2 - 6.0 * aA1; }
function C (aA1)      { return 3.0 * aA1; }

// Returns x(t) given t, x1, and x2, or y(t) given t, y1, and y2.
function calcBezier (aT, aA1, aA2) { return ((A(aA1, aA2) * aT + B(aA1, aA2)) * aT + C(aA1)) * aT; }

// Returns dx/dt given t, x1, and x2, or dy/dt given t, y1, and y2.
function getSlope (aT, aA1, aA2) { return 3.0 * A(aA1, aA2) * aT * aT + 2.0 * B(aA1, aA2) * aT + C(aA1); }

function binarySubdivide (aX, aA, aB, mX1, mX2) {
  var currentX, currentT, i = 0;
  do {
    currentT = aA + (aB - aA) / 2.0;
    currentX = calcBezier(currentT, mX1, mX2) - aX;
    if (currentX > 0.0) {
      aB = currentT;
    } else {
      aA = currentT;
    }
  } while (Math.abs(currentX) > SUBDIVISION_PRECISION && ++i < SUBDIVISION_MAX_ITERATIONS);
  return currentT;
}

function newtonRaphsonIterate (aX, aGuessT, mX1, mX2) {
 for (var i = 0; i < NEWTON_ITERATIONS; ++i) {
   var currentSlope = getSlope(aGuessT, mX1, mX2);
   if (currentSlope === 0.0) {
     return aGuessT;
   }
   var currentX = calcBezier(aGuessT, mX1, mX2) - aX;
   aGuessT -= currentX / currentSlope;
 }
 return aGuessT;
}

function LinearEasing (x) {
  return x;
}

var src = function bezier (mX1, mY1, mX2, mY2) {
  if (!(0 <= mX1 && mX1 <= 1 && 0 <= mX2 && mX2 <= 1)) {
    throw new Error('bezier x values must be in [0, 1] range');
  }

  if (mX1 === mY1 && mX2 === mY2) {
    return LinearEasing;
  }

  // Precompute samples table
  var sampleValues = float32ArraySupported ? new Float32Array(kSplineTableSize) : new Array(kSplineTableSize);
  for (var i = 0; i < kSplineTableSize; ++i) {
    sampleValues[i] = calcBezier(i * kSampleStepSize, mX1, mX2);
  }

  function getTForX (aX) {
    var intervalStart = 0.0;
    var currentSample = 1;
    var lastSample = kSplineTableSize - 1;

    for (; currentSample !== lastSample && sampleValues[currentSample] <= aX; ++currentSample) {
      intervalStart += kSampleStepSize;
    }
    --currentSample;

    // Interpolate to provide an initial guess for t
    var dist = (aX - sampleValues[currentSample]) / (sampleValues[currentSample + 1] - sampleValues[currentSample]);
    var guessForT = intervalStart + dist * kSampleStepSize;

    var initialSlope = getSlope(guessForT, mX1, mX2);
    if (initialSlope >= NEWTON_MIN_SLOPE) {
      return newtonRaphsonIterate(aX, guessForT, mX1, mX2);
    } else if (initialSlope === 0.0) {
      return guessForT;
    } else {
      return binarySubdivide(aX, intervalStart, intervalStart + kSampleStepSize, mX1, mX2);
    }
  }

  return function BezierEasing (x) {
    // Because JavaScript number are imprecise, we should guarantee the extremes are right.
    if (x === 0) {
      return 0;
    }
    if (x === 1) {
      return 1;
    }
    return calcBezier(getTForX(x), mY1, mY2);
  };
};

var animations = {
  ease:  src(0.25, 0.1, 0.25, 1),
  easeIn: src(0.42, 0, 1, 1),
  easeOut: src(0, 0, 0.58, 1),
  easeInOut: src(0.42, 0, 0.58, 1),
  linear: src(0, 0, 1, 1)
};


var amator = animate;
var makeAggregateRaf_1 = makeAggregateRaf;
var sharedScheduler = makeAggregateRaf();


function animate(source, target, options) {
  var start = Object.create(null);
  var diff = Object.create(null);
  options = options || {};
  // We let clients specify their own easing function
  var easing = (typeof options.easing === 'function') ? options.easing : animations[options.easing];

  // if nothing is specified, default to ease (similar to CSS animations)
  if (!easing) {
    if (options.easing) {
      console.warn('Unknown easing function in amator: ' + options.easing);
    }
    easing = animations.ease;
  }

  var step = typeof options.step === 'function' ? options.step : noop;
  var done = typeof options.done === 'function' ? options.done : noop;

  var scheduler = getScheduler(options.scheduler);

  var keys = Object.keys(target);
  keys.forEach(function(key) {
    start[key] = source[key];
    diff[key] = target[key] - source[key];
  });

  var durationInMs = typeof options.duration === 'number' ? options.duration : 400;
  var durationInFrames = Math.max(1, durationInMs * 0.06); // 0.06 because 60 frames pers 1,000 ms
  var previousAnimationId;
  var frame = 0;

  previousAnimationId = scheduler.next(loop);

  return {
    cancel: cancel
  }

  function cancel() {
    scheduler.cancel(previousAnimationId);
    previousAnimationId = 0;
  }

  function loop() {
    var t = easing(frame/durationInFrames);
    frame += 1;
    setValues(t);
    if (frame <= durationInFrames) {
      previousAnimationId = scheduler.next(loop);
      step(source);
    } else {
      previousAnimationId = 0;
      setTimeout(function() { done(source); }, 0);
    }
  }

  function setValues(t) {
    keys.forEach(function(key) {
      source[key] = diff[key] * t + start[key];
    });
  }
}

function noop() { }

function getScheduler(scheduler) {
  if (!scheduler) {
    var canRaf = typeof window !== 'undefined' && window.requestAnimationFrame;
    return canRaf ? rafScheduler() : timeoutScheduler()
  }
  if (typeof scheduler.next !== 'function') throw new Error('Scheduler is supposed to have next(cb) function')
  if (typeof scheduler.cancel !== 'function') throw new Error('Scheduler is supposed to have cancel(handle) function')

  return scheduler
}

function rafScheduler() {
  return {
    next: window.requestAnimationFrame.bind(window),
    cancel: window.cancelAnimationFrame.bind(window)
  }
}

function timeoutScheduler() {
  return {
    next: function(cb) {
      return setTimeout(cb, 1000/60)
    },
    cancel: function (id) {
      return clearTimeout(id)
    }
  }
}

function makeAggregateRaf() {
  var frontBuffer = new Set();
  var backBuffer = new Set();
  var frameToken = 0;

  return {
    next: next,
    cancel: next,
    clearAll: clearAll
  }

  function clearAll() {
    frontBuffer.clear();
    backBuffer.clear();
    cancelAnimationFrame(frameToken);
    frameToken = 0;
  }

  function next(callback) {
    backBuffer.add(callback);
    renderNextFrame();
  }

  function renderNextFrame() {
    if (!frameToken) frameToken = requestAnimationFrame(renderFrame);
  }

  function renderFrame() {
    frameToken = 0;

    var t = backBuffer;
    backBuffer = frontBuffer;
    frontBuffer = t;

    frontBuffer.forEach(function(callback) {
      callback();
    });
    frontBuffer.clear();
  }

  
}

amator.makeAggregateRaf = makeAggregateRaf_1;
amator.sharedScheduler = sharedScheduler;

var nc = {
    __on: null,
    send: function send(m) {
        if (this.__on) {
            this.__on(m);
        }
    }

};

// controller
var Notification = function (_React$Component) {
  inherits(Notification, _React$Component);

  function Notification(props) {
    classCallCheck(this, Notification);

    // scope methods
    var _this = possibleConstructorReturn(this, (Notification.__proto__ || Object.getPrototypeOf(Notification)).call(this, props));

    _this.showNotification = _this.showNotification.bind(_this);
    _this.onMessageReceived = _this.onMessageReceived.bind(_this);
    _this.onShowComplete = _this.onShowComplete.bind(_this);
    _this.onHideComplete = _this.onHideComplete.bind(_this);

    // subscribe to NotificationCenter
    nc.__on = _this.onMessageReceived;

    // refs
    _this.ref_container = null; // container ref
    _this.ref_message = null; // message ref

    // flags
    _this.active = false;

    // the message stack
    _this.messages = [];
    return _this;
  }

  createClass(Notification, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        "div",
        { className: "etui-notification", ref: function ref(div) {
            return _this2.ref_container = div;
          }, style: { transform: 'translateY(50px)' } },
        React.createElement(
          "div",
          { className: "etui-notification-message", ref: function ref(div) {
              return _this2.ref_message = div;
            } },
          "message comes here"
        )
      );
    }
  }, {
    key: "getDuration",
    value: function getDuration() {
      return isNaN(this.props.duration) ? 1000 : Number(this.props.duration);
    }
  }, {
    key: "onMessageReceived",
    value: function onMessageReceived(m) {
      this.messages.push(m);
      this.showNotification();
    }
  }, {
    key: "showNotification",
    value: function showNotification() {
      var _this3 = this;

      if (this.messages.length > 0 && !this.active && this.ref_message && this.ref_container) {
        this.active = true;

        var message = this.messages.shift();
        this.ref_message.innerText = message;

        amator({ bottom: 0 }, { bottom: 50 }, {
          duration: this.getDuration() / 2,
          step: function step(value) {
            _this3.ref_container.style.bottom = value.bottom + "px";
          },
          done: function done() {
            _this3.onShowComplete();
          }
        });
      }
    }
  }, {
    key: "onShowComplete",
    value: function onShowComplete() {
      var _this4 = this;

      amator({ bottom: 50 }, { bottom: 0 }, {
        duration: this.getDuration() / 2,
        step: function step(value) {
          _this4.ref_container.style.bottom = value.bottom + "px";
        },
        done: function done() {
          _this4.onHideComplete();
        }
      });
    }
  }, {
    key: "onHideComplete",
    value: function onHideComplete() {
      this.active = false;
      this.showNotification();
    }
  }]);
  return Notification;
}(React.Component);

Notification.propTypes = {
  duration: PropTypes.number.isRequired // duration in miliseconds
};

Notification.defaultProps = {
  duration: 1000
};

// TODO very long notification text messes things slightly up because the overflowing text will cover the padding on the right side

Theme.apply();



//export default {Button}

export { Button, Checkbox, ConfirmButton, Label, Notification, nc as NotificationCenter, Positions, Watcher, Theme };
